------------------------------------------------
------------ 
------------    Extended CueEditor
------------    Version: 1.1.7
------------    Update date: 09.09.2020
------------ 
------------------------------------------------
------------    Created by AlexSaltsev.ru
------------------------------------------------  
------------    Thanks for using the plugin and I hope the plugin helps you make your shows easier and better! 
------------        All copies of this code are property of the author: AlexSaltsev. You cannot use the code or part of the code without the consent of the author. 
------------        I am not responsible if the plugin contains undetected bugs that could freeze or crash the console.
------------        AlexSaltsev is the only distributor and owner of the code.
------------------------------------------------
------------    Спасибо за использование плагина и надеюсь, что плагин поможет вам сделать ваши шоу легче и лучше!
------------        Все копии этого кода являются собственностью автора: AlexSaltsev. Вы не можете использовать код или часть кода без согласия автора. 
------------        Я не несу ответственности, если плагин будет содержать необнаруженные ошибки, которые могут привести к зависанию или крашу консоли. 
------------        Единственным распространителем и владельцем кода является AlexSaltsev.   
------------------------------------------------

local lang='En' --Ru or En


------------------------------------------------
------------      Golbal Functions
------------------------------------------------




function printLine(value)
    gma.feedback(value)
    gma.echo(value)
    return printLine
end

function getIndex (ma2Name)
  local handle = gma.show.getobj.handle(ma2Name)
  local index = gma.show.getobj.index(handle)
  return index
end

function getLabel (ma2Name)
  local handle = gma.show.getobj.handle(ma2Name)
  local label = gma.show.getobj.label(handle)
  return label
end

function pointSpace(typePoint, entryPoint, sizePoint)       ---    Модуль поиска пустого места
        local endPoint = entryPoint + sizePoint                --- Формируем точку выхода исходя из точки входа плюс размер
        local emptySpace                                     --- Пустая переменная
          for i = entryPoint, endPoint do                    --- Цикл поиска между точкой входа и выхода
                if getIndex(typePoint..' '..i) then         --- Находим индекс текущей позиции
                  emptySpace = 0                                --- Если есть то возвращаем ноль
                end                                            ---
          end                                                --- Это саб модуль, используется пока что только в функции getSpace
        return emptySpace                                    --- Консоль выдает овердохуя ошибок тк у пустых иконок нету класса
end

function getSpace(typePoint, entryPoint, sizePoint)                    ---    Ищем пустое место для массива
    while pointSpace(typePoint, entryPoint, sizePoint) == 0 do        --- Если модуль возващает 0, добавим к точке входа 1
        entryPoint = entryPoint + 1
    end

    return entryPoint    
end




local msgRU={
"Номер CUE для операции ",
"Не существует CUE ",
"Номер CUE куда ",
"Пустой ввод",
"Проверьте правильность",
"Введите номер Exec",
"Например 1.215",
"Не существует Exec ",
}

local msgEN={
"Enter what CUE you wanna ",
"Does not exist CUE ",
"Enter CUE where to ",
"Empty input",
"Confirm changes",
"Enter exec number",
"1.215 for exaple",
"Does not exist Exec ",
}



if lang=='Ru' then
message = msgRU
end
if lang=='En' then
message = msgEN
end


function badVersion()

local version = gma.show.getvar('version') 
local lock 
    if version:find('3.1.2') == 1 then 
        
        printLine('---------------------------------------------')
        printLine('You cant use Plugin on version: '..version..'')
        printLine('---------------------------------------------')
        
        gma.textinput('You cant use Plugin on version: '..version..'', 'Сорян бро, твоя версия: '..version..' устарела')

        lock = 1
        
    end     
 return lock
    


end

------------------------------------------------
------------      Body of Plugin
------------------------------------------------


function moveCue()

if badVersion() == 1 then goto END end
local msg=message[7]

::RESTART::

local execNum=tonumber(gma.textinput(message[6], msg))
------------      Защита от дурака
    local check=getIndex('Exec '..execNum..'')
    if check==nil then 
    msg=message[8]..execNum
    goto RESTART 
    end
------------      Защита от дурака                            
    local check=getIndex('Exec '..execNum..' cue 2')
    if check==nil then 
    msg=(message[2]..'list exec '..execNum)
    goto RESTART 
    end


local msg=''


local typeMove=gma.textinput('m=move, s=swap, c=copy, d=delete','')

------------      Защита от дурака
if ((typeMove=='m') or (typeMove=='s') or (typeMove=='c') or (typeMove=='d')) then printLine('ok') 
else printLine('not ok') 
goto RESTART 
end 

local msgType
if typeMove=='m' then msgType='MOVE' 
elseif typeMove=='s' then msgType='SWAP'    
elseif typeMove=='c' then msgType='COPY'    
elseif typeMove=='d' then msgType='DELETE'                
end     



::AGAIN::
local otkudaCue=tonumber(gma.textinput(message[1]..msgType, msg))
------------      Защита от дурака                            
local check=getIndex('Exec '..execNum..' cue '..otkudaCue)
if check==nil then 
    msg=message[2]..otkudaCue
    goto AGAIN 
end

    if otkudaCue==nil then 
        msg=message[4]
        goto AGAIN 
    end

local name1    
local name2
local kudaCue
local msg

------------      Если не удаляем то
if typeMove~='d' then
kudaCue=tonumber(gma.textinput(message[3]..msgType, '')) 
------------      Защита от дурака
    if kudaCue==nil then 
        msg=message[4]
        goto AGAIN 
    end     

    name1=otkudaCue    
    name2=kudaCue    
    msg=(msgType..' Exec '..execNum..' CUE '..name1..' on CUE '..name2)
    
else 
------------      Если  удаляем то
    name1=otkudaCue  
    msg=(msgType..' Exec '..execNum..' CUE '..name1..'')
end

------------      Confirm

local confirm = gma.gui.confirm (message[5], msg)
    if (not confirm) then
        goto RESTART 
    end    


------------      Main function


        if typeMove=='m' then
------------      Move  

------------      Если нашли точку то                    
            local checkDot=tostring(otkudaCue)                    
            if string.find(checkDot, '%p+') then 
                
                printLine('Dot found') 
                local endCue = getSpace('exec '..execNum..' cue ', 1, 10)                
                local range=(endCue-otkudaCue)-1
                
------------      Если Cue ниже по списку                
                if otkudaCue>kudaCue then
                range=(endCue-otkudaCue)
                end
                
                local editCue=string.gsub(checkDot, '.%d+', '') ---remove any dot cue
                
                gma.cmd('select exec '..execNum..'')
                for i=0, range do
                    gma.cmd('move cue '..(endCue-1-i)..' at cue '..(endCue-i)..'')
                end
                gma.cmd('move cue '..otkudaCue..' at '..kudaCue)
                goto END
            end
            
            
            
            if otkudaCue<kudaCue then
------------      Сверху вниз 
                printLine('Move >>>')
                local range=(kudaCue-otkudaCue)-1 --4
    
                gma.cmd('select exec '..execNum..'')
                gma.cmd('move cue '..otkudaCue..' at cue '..(kudaCue-1)..'99') 
                
                for i=0, range do
                gma.cmd('move cue '..(otkudaCue+1+i)..' at cue '..(otkudaCue+i)..'')
                end
                gma.cmd('move cue '..(kudaCue-1)..'99 at cue '..(kudaCue)..'') 
                
            elseif otkudaCue>kudaCue then
------------      Снизу вверх        
                printLine('Move <<<')
                local range=(otkudaCue-kudaCue)-1 --3
                
                gma.cmd('select exec '..execNum..'')
                gma.cmd('move cue '..otkudaCue..' at cue '..(kudaCue)..'99') 
                
                for i=0, range do
                gma.cmd('move cue '..(otkudaCue-1-i)..' at cue '..(otkudaCue-i)..'')    
                end
                gma.cmd('move cue '..(kudaCue)..'99 at cue '..(kudaCue)..'')
                    
            
            end

            
------------      End Move 
        end       
        if typeMove=='s' then
------------      Swap             
            printLine('Swap')
            gma.cmd('select exec '..execNum..'')
            gma.cmd('move cue '..otkudaCue..' at cue '..kudaCue..'.999') 
            gma.cmd('move cue '..kudaCue..' at cue '..otkudaCue..'') 
            gma.cmd('move cue '..kudaCue..'.999 at cue '..kudaCue) 
------------      End Swap             
        end 

        if typeMove=='c' then
------------      Copy            
            printLine('Copy')
            local endCue = getSpace('exec '..execNum..' cue ', 1, 10)
            local range=(endCue-kudaCue)-1                                              

            gma.cmd('select exec '..execNum..'')                        
            gma.cmd('copy cue '..otkudaCue..' at cue '..(kudaCue-1)..'.999 /nc')                    
            gma.cmd('move cue '..(kudaCue)..' thru '..(kudaCue+range)..' at cue '..(endCue)..'')                   
            gma.cmd('move cue '..(kudaCue-1)..'.999 at cue '..kudaCue..' /nc')
            
            for i=0, range do                
                gma.cmd('move cue '..(endCue+i)..' at '..(kudaCue+1+i)..'')
            end
------------      End Copy
        end
        
        if typeMove=='d' then
------------      Delete            
            printLine('Delete')
            local endCue = getSpace('exec '..execNum..' cue ', 1, 10)
            local range=(endCue-otkudaCue)-1                                              

            gma.cmd('select exec '..execNum..'')        
            gma.cmd('delete cue '..otkudaCue..' /nc')
    
            for i=0, range-1 do                
                gma.cmd('move cue '..(otkudaCue+1+i)..' at '..(otkudaCue+i)..'')
            end
------------      End Delete
        end
            
   
  
                

gma.cmd('select exec 1.101')        
::END::
end
return moveCue